/** The abstract superclass of all binary operator expression AST
 * nodes. */

package AST;

import Typechecker.*;
import Evaluator.*;
import IL.*;
import Helpers.*;

public abstract class BinopExpr extends Expr {
    // Instance variables

    // AST subtrees:
    protected Expr arg1;
    protected Expr arg2;

    // Constructor
    public BinopExpr(Expr a1, Expr a2, int ln) {
	super(ln);
	arg1 = a1;
	arg2 = a2;
    }

    // AST printing

    /** return a printable representation of this ast node. **/
    public String toString(String indent) {
	return
	    "(" + arg1.toString(indent) + ") " + opString() + 
	    " (" + arg2.toString(indent) + ")";
    }

    /** return the printable name of this operator */
    protected abstract String opString();
}
