/** The AST node for the 'boolean' type. */

package AST;

import Typechecker.*;
import IL.*;
import Helpers.*;

public class BooleanType extends Type {
    // Constructor
    public BooleanType(int ln) {
	super(ln);
    }


    // AST printing
    public String toString(String indent) {
	return "boolean";
    }


    // Typechecking operations

    /** Check that this type is a legal type, and if so return
     * corresponding resolved type to use during typechecking. */
    protected ResolvedType computeResolvedType(SymbolTable st)
		throws TypecheckCompilerException {
	return new ResolvedBooleanType();
    }
}
