/** The AST node for types created by class declarations. */

package AST;

import Typechecker.*;
import IL.*;
import Helpers.*;

public class ClassType extends Type {
    // Instance variables

    // AST subtrees:
    protected String class_name;


    // Constructor
    public ClassType(String cn, int ln) {
	super(ln);
	class_name = cn;
    }


    // AST printing
    public String toString(String indent) {
	return class_name;
    }


    // Typechecking operations

    /** Check that this type is a legal type, and if so return
     * corresponding resolved type to use during typechecking. */
    protected ResolvedType computeResolvedType(SymbolTable st)
		throws TypecheckCompilerException {
	// compute and return the resolved type
	return new ResolvedClassType(class_name, st, line_number);
    }
}
