/** The abstract superclass for variable declarations in classes */

package AST;

import Typechecker.*;
import Evaluator.*;
import IL.*;
import Helpers.*;

public abstract class ClassVarDecl extends VarDecl {
    // Constructor
    public ClassVarDecl(Type t, String n, int ln) {
	super(t, n, ln);
    }


    // Typechecking operations

    /** declare this class variable in the class symbol table
     * (implemented in concrete subclasses) */
    public abstract void computeInterface(ClassSymbolTable st) 
	throws TypecheckCompilerException;


    // Evaluation operations

    /** declare this class variable in the class environment
     * (implemented in concrete subclasses) */
    public abstract void declareVariable(ClassEnvironment env);


    // Lowering (i.e., intermediate-language generation) operations

    /** Augment an intermediate-language program with whatever
     * declarations are needed for this class variable, where the
     * symbol table is for the enclosing class. */
    public abstract void lower(ILProgram il_program,
			       ClassSymbolTable class_st);
}
