/** The AST node for greater-than-or-equal ('>=') binary operator
 * expressions. */

package AST;

import Typechecker.*;
import Evaluator.*;
import IL.*;
import Helpers.*;

public class GreaterEqualExpr extends ComparisonBinopExpr {
    // Constructor
    public GreaterEqualExpr(Expr a1, Expr a2, int ln) {
	super(a1, a2, ln);
    }


    // AST printing

    /** return the printable name of this operator */
    protected String opString() {
	return ">=";
    }


    // Evaluation operations

    /** Evaluate the integer version of this operation */
    protected boolean evaluateIntOperation(int arg1_value, 
					   int arg2_value) {
	return arg1_value >= arg2_value;
    }


    // Lowering (i.e., intermediate-language generation) operations

    /** Return the integer version of this operation */
    protected ILExpr loweredIntOperation(ILExpr arg1_expr, 
					 ILExpr arg2_expr) {
	return new ILIntGreaterThanOrEqualExpr(arg1_expr, arg2_expr);
    }
}
