/** The AST node for the 'int' type. */

package AST;

import Typechecker.*;
import IL.*;
import Helpers.*;

public class IntType extends Type {
    // Constructor
    public IntType(int ln) {
	super(ln);
    }


    // AST printing
    public String toString(String indent) {
	return "int";
    }


    // Typechecking operations

    /** Check that this type is a legal type, and if so return
     * corresponding resolved type to use during typechecking. */
    protected ResolvedType computeResolvedType(SymbolTable st)
		throws TypecheckCompilerException {
	return new ResolvedIntType();
    }
}
