/** The AST node for integer negation ('-') unary operator expressions. */

package AST;

import Typechecker.*;
import Evaluator.*;
import IL.*;
import Helpers.*;

public class NegateExpr extends ArithmeticUnopExpr {
    // Constructor
    public NegateExpr(Expr a, int ln) {
	super(a, ln);
    }


    // AST printing

    /** return the printable name of this operator */
    protected String opString() {
	return "-";
    }


    // Evaluation operations

    /** Evaluate the integer version of this operation */
    protected int evaluateIntOperation(int arg_value) {
	return - arg_value;
    }


    // Lowering (i.e., intermediate-language generation) operations

    /** Return the integer version of this operation */
    protected ILExpr loweredIntOperation(ILExpr arg_expr) {
	return new ILIntNegateExpr(arg_expr);
    }
}
