/** The AST node for boolean negation ('!') unary operator expressions. */

package AST;

import Typechecker.*;
import Evaluator.*;
import IL.*;
import Helpers.*;

public class NotExpr extends BooleanUnopExpr {
    // Constructor
    public NotExpr(Expr a, int ln) {
	super(a, ln);
    }


    // AST printing

    /** return the printable name of this operator */
    protected String opString() {
	return "!";
    }


    // Evaluation operations

    /** Evaluate this operation */
    protected boolean evaluateBooleanOperation(boolean arg_value) {
	return ! arg_value;
    }


    // Lowering (i.e., intermediate-language generation) operations

    /** Return this operation */
    protected ILExpr loweredBooleanOperation(ILExpr arg_expr) {
	return new ILLogicalNegateExpr(arg_expr);
    }
}
