/** The abstract superclass of all unary operator expression AST
 * nodes. */

package AST;

import Typechecker.*;
import Evaluator.*;
import IL.*;
import Helpers.*;

public abstract class UnopExpr extends Expr {
    // Instance variables

    // AST subtrees:
    protected Expr arg;

    // Constructor
    public UnopExpr(Expr a, int ln) {
	super(ln);
	arg = a;
    }

    // AST printing

    /** return a printable representation of this ast node. **/
    public String toString(String indent) {
	return opString() + " (" + arg.toString(indent) + ")";
    }

    /** return the printable name of this operator */
    protected abstract String opString();
}
