/* This file defines some functions that may be called by the compiled
   MiniJava program */

#include <stdio.h>
#include <stdlib.h>

// print out an integer value
void println_int(int value) {
  printf("%d\n", value);
}

// allocate bytes bytes of (uninitialized) memory, and return a
// pointer to it
void* allocate(int bytes) {
  return malloc(bytes);
}

// allocate base_bytes + num_elems*elems_bytes bytes of cleared
// memory, and return a pointer to it
void* allocate_sequence(int base_bytes, int num_elems, int elems_bytes) {
  return calloc(base_bytes + num_elems * elems_bytes, 1);
}

// report an exception and die
void throw_exception(char* message) {
  fprintf(stderr, "Unhandled exception: %s\n", message);
  exit(-1);
}
