/** The class for the environment for the body of a (non-static)
 * method. */

package Evaluator;

import Helpers.*;
import java.util.*;

public class MethodEnvironment extends CodeEnvironment {
    // Instance variables

    // the calling environment, or null if this is the main class's
    // main method.  (for tracing & debugging purposes.)
    protected CodeEnvironment calling_env;


    // Constructor

    /** create the environment for a method */
    public MethodEnvironment(Environment enclosing_env, 
			     CodeEnvironment ce) {
	super(enclosing_env);
	calling_env = ce;
    }


    // Tracing operations

    /** return the number of callers of this method environment (0 =
     * the main class's main method) */
    public int caller_depth() {
	if (calling_env == null) {
	    return 0;
	} else {
	    return 1 + calling_env.caller_depth();
	}
    }
}
