/** The class for the null value. */

package Evaluator;

import Helpers.*;

public class NullValue extends Value {
    // Constructor
    public NullValue() { }

    // Printing operations
    public String toString() { 
	return "null";
    }

    // Evaluation operations

    /** look up the method with the given name in the receiver
     * instance, throwing an evaluation error if null.  return the
     * method declaration that is invoked. */
    public MethodDeclAndEnv lookupMethod(String name, int line_number)
		throws EvalCompilerException {
	throw new EvalCompilerException("dereferencing null", line_number);
    }
}
