/** This class is used to report errors with the input program during
 * evaluation. */

package Helpers;

public class EvalCompilerException extends CompilerException {
    /** A standard interface for reporting an error */
    public EvalCompilerException(String message) {
	super("Eval error: " + message);
    }

    /** An interface to use if the line of the input where the error
     * occurs is known */
    public EvalCompilerException(String message, int line) {
	super("Eval error: " + message, line);
    }

    /** An interface to use if the line and column of the input where
     * the error occurs is known */
    public EvalCompilerException(String message, int line, int column) {
	super("Eval error: " + message, line, column);
    }
}
