/** This class is used to throw errors that correspond to
 * unimplemented parts of the compiler. */

package Helpers;

public class UnimplementedError extends InternalCompilerError {
    /** A standard interface for reporting an error */
    public UnimplementedError(String message) {
	super("Unimplemented: " + message);
    }

    /** An interface to use if the line of the input where the error
     * occurs is known */
    public UnimplementedError(String message, int line) {
	super("Unimplemented: " + message, line);
    }

    /** An interface to use if the line and column of the input where
     * the error occurs is known */
    public UnimplementedError(String message, int line, int column) {
	super("Unimplemented: " + message, line, column);
    }
}
