/** This is the class for assignment statements in the IL
 * (intermediate language) */

package IL;

import CodeGen.*;
import java.io.*;

public class ILAssignStmt extends ILExprStmt {
    // Instance variables
    protected ILAssignableExpr lhs;


    // Constructor
    public ILAssignStmt(ILAssignableExpr l, ILExpr r) {
	super(r);
	lhs = l;
    }


    // Printing
    public String toString() {
	return lhs.toString() + " := " + super.toString();
    }


    // Target code generation operations

    /** generate target code for this statement */
    public void codegen(Target target) throws IOException {
	target.emitAssign(lhs, rhs);
    }
}
