/** This is the abstract superclass of all IL (intermediate language)
 * expressions that may also appear on the left-hand-sides of
 * assignments, i.e., can be l-values. */

package IL;

import CodeGen.*;
import java.io.*;

public abstract class ILAssignableExpr extends ILExpr {
    // Constructor
    public ILAssignableExpr() { }


    // Target code generation operations

    /** generate target code to assign the argument to this
     * left-hand-side expression, given the set of scratch registers
     * available & allocated. */
    public abstract void codegenAssign(Location rhs_location, Target target)
	throws IOException;
}
