/** This is the abstract superclass of all IL (intermediate language)
 * expressions that are binary operators. */

package IL;

import CodeGen.*;
import java.io.*;

public abstract class ILBinopExpr extends ILExpr {
    // Instance variables
    protected ILExpr arg1;	// the first operand
    protected ILExpr arg2;	// the second operand


    // Constructor
    public ILBinopExpr(ILExpr a1, ILExpr a2) {
	arg1 = a1;
	arg2 = a2;
    }


    // Printing
    public String toString() {
	return arg1.toString() + " " + opToString() + " " + arg2.toString();
    }
    // return the name of the operator
    protected abstract String opToString();
}
