/** This is the class for negated conditional branch statements in the
 * IL (intermediate language).  Branches to the target label if the
 * argument expression is false (zero or null), falls through
 * otherwise. */

package IL;

import CodeGen.*;
import java.io.*;

public class ILConditionalBranchFalseStmt extends ILConditionalBranchStmt {
    // Constructor
    public ILConditionalBranchFalseStmt(ILExpr test, ILLabel target_label) {
	super(test, target_label);
    }


    // Printing
    protected String opToString() {
	return "iffalse";
    }


    // Target code generation operations

    /** generate target code for this statement */
    public void codegen(Target target) throws IOException {
	target.emitConditionalBranchFalse(test, target_label);
    }
}
