/** This is the abstract superclass for conditional branch statements
 * in the IL (intermediate language). */

package IL;

import CodeGen.*;
import java.io.*;

public abstract class ILConditionalBranchStmt extends ILStmt {
    // Instance variables

    protected ILExpr test;	// the expression tested

    // the label to branch to if the test succeeds, which should be
    // the label of an ILLabelStmt in the same function
    protected ILLabel target_label;


    // Constructor
    public ILConditionalBranchStmt(ILExpr t, ILLabel l) {
	test = t;
	target_label = l;
    }


    // Printing
    public String toString() {
	return opToString() + " " + test.toString() + 
	    " goto " + target_label.toString() + ";";
    }

    // return the branch operator name
    protected abstract String opToString();
}
