/** This is the class for conditional branch statements in the IL
 * (intermediate language).  Branches to the label if the argument
 * expression is true (non-zero or non-null), falls through
 * otherwise. */

package IL;

import CodeGen.*;
import java.io.*;

public class ILConditionalBranchTrueStmt extends ILConditionalBranchStmt {
    // Constructor
    public ILConditionalBranchTrueStmt(ILExpr test, ILLabel target_label) {
	super(test, target_label);
    }


    // Printing
    protected String opToString() {
	return "iftrue";
    }


    // Target code generation operations

    /** generate target code for this statement */
    public void codegen(Target target) throws IOException {
	target.emitConditionalBranchTrue(test, target_label);
    }
}
