/** This is the class of IL (intermediate language) expressions that
 * are double-precision floating-point constants */

package IL;

import CodeGen.*;
import java.io.*;

public class ILDoubleConstantExpr extends ILExpr {
    // Instance variable
    protected double value;


    // Constructor
    public ILDoubleConstantExpr(double v) {
	value = v;
    }


    // Printing
    public String toString() {
	return Double.toString(value);
    }


    // Target code generation operations

    /** generate target code for this expression, given the set of
     * scratch registers available & allocated. return the location
     * where the result is. */
    public Location codegen(Target target) throws IOException {
	return target.emitDoubleConstant(value);
    }
}
