/** This is the class of IL (intermediate language) expressions that
 * are double-precision floating-point divide operators */

package IL;

import CodeGen.*;
import java.io.*;

public class ILDoubleDivExpr extends ILBinopExpr {
    // Constructor
    public ILDoubleDivExpr(ILExpr arg1, ILExpr arg2) {
	super(arg1, arg2);
    }


    // Printing
    protected String opToString() {
	return "/.double";
    }


    // Target code generation operations

    /** generate target code for this expression, given the set of
     * scratch registers available & allocated. return the location
     * where the result is. */
    public Location codegen(Target target) throws IOException {
	return target.emitDoubleDiv(arg1, arg2);
    }
}
