/** This is the class of IL (intermediate language) expressions that
 * are double-precision floating-point negation operators. */

package IL;

import CodeGen.*;
import java.io.*;

public class ILDoubleNegateExpr extends ILUnopExpr {
    // Constructor
    public ILDoubleNegateExpr(ILExpr arg) {
	super(arg);
    }


    // Printing
    protected String opToString() {
	return "-.double";
    }


    // Target code generation operations

    /** generate target code for this expression, given the set of
     * scratch registers available & allocated. return the location
     * where the result is. */
    public Location codegen(Target target) throws IOException {
	return target.emitDoubleNegate(arg);
    }
}
