/** The class for the IL double type. */

package IL;

import CodeGen.*;

public class ILDoubleType extends ILType {
    // Constructor
    public ILDoubleType() { }


    // Accessors

    // return whether this is the double type
    public boolean isDoubleType() {
	return true;
    }


    // Printing operations

    // return a printable string representation of this type.
    public String toString() { 
	return "double"; 
    }


    // Target code generation operations

    /** compute the layout of this type */
    public void doLayout(Target target) {
	// nothing to do
    }

    /** return the size in bytes of a value of this type on the given
     * target machine */
    public int byteSize(Target target) {
	return target.doubleByteSize();
    }

    /** return the alignment constraint in bytes of a value of this
     * type on the given target machine, i.e., at what multiple of
     * bytes must a value of this type begin on */
    public int byteAlign(Target target) {
	return target.doubleByteAlign();
    }
}
