/** This is the class of double-precision floating-point initializers
 * for IL (intermediate language) global variables */

package IL;

import CodeGen.*;
import java.io.*;

public class ILDoubleValue extends ILValue {
    // Instance variable
    protected double value;

    // Constructor
    public ILDoubleValue(double v) {
	value = v;
    }

    // Printing
    public String toString() {
	return Double.toString(value);
    }


    // Target code generation operations

    /** generate code for this initializer */
    public void codegenInitializer(Target target) throws IOException {
	target.emitDoubleInitializer(value);
    }
}
