/** This is the abstract superclass of all IL (intermediate language)
 * expressions */

package IL;

import CodeGen.*;
import java.io.*;

public abstract class ILExpr {
    // Constructor
    public ILExpr() { }

    // Printing
    public abstract String toString();


    // Target code generation operations

    /** generate target code for this expression, given the set of
     * scratch registers available & allocated. return the location
     * where the result is. */
    public abstract Location codegen(Target target) throws IOException;

    /** generate target code for this expression, where the result will
     * be used in a conditional branch.  return the location where the
     * result is. */
    public Location codegenTest(Target target) throws IOException {
	// by default, compute the argument's value and the test
	// whether it's true
	return target.emitTest(this);
    }
}
