/** This is the class for simple statements in the IL (intermediate
 * language) that just evaluate their right-hand-sides and ignore the
 * result.  (The ILAssignStmt subclass adds a left-hand-side.) */

package IL;

import CodeGen.*;
import java.io.*;

public class ILExprStmt extends ILStmt {
    // Instance variables
    protected ILExpr rhs;


    // Constructor
    public ILExprStmt(ILExpr r) {
	rhs = r;
    }


    // Printing
    public String toString() {
	return rhs.toString() + ";";
    }


    // Target code generation operations

    /** generate target code for this statement */
    public void codegen(Target target) throws IOException {
	target.emitExpr(rhs);
    }
}
