/** This is a helper class to represent formal variable
 * declarations in IL (intermediate language) functions */

package IL;

import CodeGen.*;

public class ILFormalVarDecl extends ILVarDecl {
    // Constructor
    public ILFormalVarDecl(ILType type, String name) {
	super(type, name);
    }

    // whether this var decl is a formal
    public boolean isFormal() {
	return true;
    }


    // Target code generation operations

    /** return the offset in the enclosing function's stack frame for
     * this variable, relative to the frame pointer, of variables of
     * this kind (local or formal) */
    protected int getBaseOffset(Target target) {
	return target.getFormalBaseOffset();
    }
}
