/** This is the class of IL (intermediate language) expressions that
 * take the address of a global variable. */

package IL;

import CodeGen.*;
import java.io.*;

public class ILGlobalAddressExpr extends ILExpr {
    // Instance variable

    // the global variable whose address is yielded by this expression
    protected ILGlobalVar global_var;


    // Constructor
    public ILGlobalAddressExpr(ILGlobalVar v) {
	global_var = v;
    }


    // Printing
    public String toString() {
	return "&" + global_var.toString();
    }


    // Target code generation operations

    /** generate target code for this expression, given the set of
     * scratch registers available & allocated. return the location
     * where the result is. */
    public Location codegen(Target target) throws IOException {
	return target.emitGlobalAddress(global_var.getName());
    }
}
