/** This is the class for references to IL (intermediate language)
 * global variables or functions.  It's a kind of handle for referring
 * to global declarations, e.g. in ILGlobalAddressExpr and
 * ILGlobalAddressValue.  ILGlobalVars are returned by ILProgram and
 * ILFunDecl operations such as lookupGlobalVar and
 * newInitializedGlobalVar.  Since we can create references to global
 * variables before they've been declared, e.g. for mutually recursive
 * functions & initialized global variables, then we just use a simple
 * string name for the variable, instead of its declaration. */

package IL;

public class ILGlobalVar {
    // Instance variable
    protected String name;  // the name of this global variable

    // Constructor
    public ILGlobalVar(String n) {
	name = n;
    }

    // Accessor
    public String getName() {
	return name;
    }

    // Printing
    public String toString() {
	return name;
    }
}
