/** This is the class for IL (intermediate language) global variable
 * declarations, by default uninitialized (but see the
 * ILInitializedGlobalVarDecl subclass for an initialized version). */

package IL;

import CodeGen.*;
import java.io.*;

public class ILGlobalVarDecl {
    // Instance variables
    protected ILType type;	// the type of the global
    protected String name;	// its name (which should be unique
				// among other globals and functions)

    // Constructor
    public ILGlobalVarDecl(ILType t, String n) {
	type = t;
	name = n;
    }

    // Accessors
    public String getName() {
	return name;
    }

    public ILType getType() {
	return type;
    }

    // Printing
    public String toString() {
	return type.toString() + " " + name + ";";
    }


    // Target code generation operations

    /** generate code for this global variable declaration */
    public void codegen(Target target) throws IOException {
	target.emitUninitializedGlobalVarDecl(type, name);
    }
}
