/** This is the class for IL (intermediate language) global variable
 * declarations that are initialized. */

package IL;

import CodeGen.*;
import java.io.*;

public class ILInitializedGlobalVarDecl extends ILGlobalVarDecl {
    // Instance variable
    protected ILValue initValue;    // the initializing value

    // Constructor
    public ILInitializedGlobalVarDecl(ILType t, String n, ILValue i) {
	super(t, n);
	initValue = i;
    }

    // Printing
    public String toString() {
	return type.toString() + " " + name + " = " + 
	    initValue.toString() + ";";
    }


    // Target code generation operations

    /** generate code for this global variable declaration */
    public void codegen(Target target) throws IOException {
	target.emitInitializedGlobalVarDecl(type, name, initValue);
    }
}
