/** This is the class of IL (intermediate language) expressions that
 * are integer constants */

package IL;

import CodeGen.*;
import java.io.*;

public class ILIntConstantExpr extends ILExpr {
    // Instance variable
    protected int value;


    // Constructor
    public ILIntConstantExpr(int v) {
	value = v;
    }


    // Printing
    public String toString() {
	return Integer.toString(value);
    }


    // Target code generation operations

    /** generate target code for this expression, given the set of
     * scratch registers available & allocated. return the location
     * where the result is. */
    public Location codegen(Target target) throws IOException {
	return target.emitIntConstant(value);
    }
}
