/** This is the class of IL (intermediate language) expressions that
 * are integer negation operators. */

package IL;

import CodeGen.*;
import java.io.*;

public class ILIntNegateExpr extends ILUnopExpr {
    // Constructor
    public ILIntNegateExpr(ILExpr arg) {
	super(arg);
    }


    // Printing
    protected String opToString() {
	return "-.int";
    }


    // Target code generation operations

    /** generate target code for this expression, given the set of
     * scratch registers available & allocated. return the location
     * where the result is. */
    public Location codegen(Target target) throws IOException {
	return target.emitIntNegate(arg);
    }
}
