/** This is the class of IL (intermediate language) expressions that
 * convert integers to double-precision floating-point numbers. */

package IL;

import CodeGen.*;
import java.io.*;

public class ILIntToDoubleExpr extends ILUnopExpr {
    // Constructor
    public ILIntToDoubleExpr(ILExpr arg) {
	super(arg);
    }


    // Printing
    protected String opToString() {
	return "(double)";
    }


    // Target code generation operations

    /** generate target code for this expression, given the set of
     * scratch registers available & allocated. return the location
     * where the result is. */
    public Location codegen(Target target) throws IOException {
	return target.emitIntToDouble(arg);
    }
}
