/** This is the class of integer initializers for IL (intermediate
 * language) global variables */

package IL;

import CodeGen.*;
import java.io.*;

public class ILIntValue extends ILValue {
    // Instance variable
    protected int value;

    // Constructor
    public ILIntValue(int v) {
	value = v;
    }

    // Printing
    public String toString() {
	return Integer.toString(value);
    }


    // Target code generation operations

    /** generate code for this initializer */
    public void codegenInitializer(Target target) throws IOException {
	target.emitIntInitializer(value);
    }
}
