/** This is the class for labels in the IL (intermediate language),
 * referenced by label statements, branch/goto statements, and
 * ILLabelAddressValue initializers, and created by ILFunDecl's
 * newLabel operation. */

package IL;

public class ILLabel {
    // Instance variable
    protected String name;    // the name of the label, which should
			      // be unique among all labels in the
			      // whole program


    // Constructor
    public ILLabel(String n) {
	name = n;
    }


    // Accessor
    public String getName() {
	return name;
    }


    // Printing
    public String toString() {
	return name;
    }
}
