/** This is the class of IL (intermediate language) global data
 * initializers that are the addresses of labels */

package IL;

import CodeGen.*;
import java.io.*;

public class ILLabelAddressValue extends ILValue {
    // Instance variable
    protected ILLabel label;


    // Constructor
    public ILLabelAddressValue(ILLabel l) {
	label = l;
    }


    // Printing
    public String toString() {
	return "&" + label.toString();
    }


    // Target code generation operations

    /** generate code for this initializer */
    public void codegenInitializer(Target target) throws IOException {
	target.emitLabelAddressInitializer(label);
    }
}
