/** This is the class for label statements in the IL (intermediate
 * language), which can be branched to by conditional and
 * unconditional branch statements in the same function, and whose
 * address can be taken by ILLabelAddressValue initializers for any
 * global variable. */

package IL;

import CodeGen.*;
import java.io.*;

public class ILLabelStmt extends ILStmt {
    // Instance variable
    ILLabel label;


    // Constructor
    public ILLabelStmt(ILLabel l) {
	label = l;
    }


    // Printing
    public String toString() {
	return "label " + label.toString() + ";";
    }


    // Target code generation operations

    /** generate target code for this statement */
    public void codegen(Target target) throws IOException {
	target.emitLabel(label);
    }
}
