/** This is the helper class for members of IL (intermediate language)
 * record initializers for global variables */

package IL;

import CodeGen.*;
import java.io.*;

public class ILRecordValueMember {
    // Instance variables
    protected ILType type;	// the type of this member
    protected String name;	// the name of this member
    protected ILValue value;	// the initial value of this member


    // Constructor
    public ILRecordValueMember(ILType t, String n, ILValue v) {
	type = t;
	name = n;
	value = v;
    }


    // Printing operations
    public String toString() { 
	return name + " = " + value.toString();
    }


    // Target code generation operations

    /** generate code to initialize this member.  isAligned says
     * whether the alignment is already satisfied */
    public void codegenInitializer(Target target, boolean isAligned)
		throws IOException {
	if (! isAligned) {
	    target.emitAlignDirective(type);
	}
	value.codegenInitializer(target);
    }
}
