/** This is the class of IL (intermediate language) expressions that
 * are calls to external library functions. */

package IL;

import CodeGen.*;
import java.io.*;
import java.util.*;

public class ILRuntimeCallExpr extends ILFunCallExpr {
    // Instance variables
    protected String fun_name;	// the name of the library function to call


    // Constructor
    public ILRuntimeCallExpr(ILType rt, String fn, List<ILExpr> as) {
	super(rt, as);
	fun_name = fn;
    }


    // Printing
    protected String calleeToString() {
	return fun_name;
    }


    // Target code generation operations

    /** generate target code for this expression, given the set of
     * scratch registers available & allocated. return the location
     * where the result is. */
    public Location codegen(Target target) throws IOException {
	return target.emitRuntimeCall(result_type, fun_name, args);
    }
}
