/** This is the class for references to IL (intermediate language)
 * formal, local, and temp variables.  It's a kind of handle for
 * referring to declarations, e.g. in ILVarExpr expressions.  ILVars
 * are returned by ILFunDecl operations such as lookupVar and
 * newTempVar. */

package IL;

public class ILVar {
    // Instance variable
    protected ILVarDecl decl;  // the declaration of this variable


    // Constructor
    public ILVar(ILVarDecl d) {
	decl = d;
    }


    // Accessor
    public ILVarDecl getDecl() {
	return decl;
    }


    // Printing
    public String toString() {
	return decl.getName();
    }
}
