/** The class for a symbol table for a scope that's lexically nested
 * within some other scope. */

package Typechecker;

import Helpers.*;

public abstract class NestedSymbolTable extends SymbolTable {
    // Instance variables

    /** the symbol table for the lexically enclosing scope */
    protected SymbolTable enclosing_symbol_table;


    // Constructor

    public NestedSymbolTable(SymbolTable t) { 
	enclosing_symbol_table = t;
    }


    // Typechecking operations

    /** Return the symbol table for the class named 'class_name', or
     * throw a TypecheckCompilerException if the class isn't declared. */
    public ClassSymbolTable lookupClass(String class_name, int line_number) 
		throws TypecheckCompilerException {
	// this scope doesn't declare any classes; search the
	// lexically enclosing scope
	return enclosing_symbol_table.lookupClass(class_name, line_number);
    }
}
